diff --git a/MAINTAINERS b/MAINTAINERS
index 395f26ba86..d72e040a9a 100644
--- a/MAINTAINERS
+++ b/MAINTAINERS
@@ -3154,8 +3154,6 @@ S: Supported
 F: qapi/
 X: qapi/*.json
 F: include/qapi/
-X: include/qapi/qmp/
-F: include/qapi/qmp/dispatch.h
 F: tests/qapi-schema/
 F: tests/unit/test-*-visitor.c
 F: tests/unit/test-qapi-*.c
@@ -3178,8 +3176,7 @@ QObject
 M: Markus Armbruster <armbru@redhat.com>
 S: Supported
 F: qobject/
-F: include/qapi/qmp/
-X: include/qapi/qmp/dispatch.h
+F: include/qobject/
 F: scripts/coccinelle/qobject.cocci
 F: tests/unit/check-qdict.c
 F: tests/unit/check-qjson.c
diff --git a/include/qapi/qmp/dispatch.h b/include/qapi/qmp-registry.h
similarity index 100%
rename from include/qapi/qmp/dispatch.h
rename to include/qapi/qmp-registry.h
diff --git a/include/qapi/qmp/json-parser.h b/include/qobject/json-parser.h
similarity index 100%
rename from include/qapi/qmp/json-parser.h
rename to include/qobject/json-parser.h
diff --git a/include/qapi/qmp/json-writer.h b/include/qobject/json-writer.h
similarity index 100%
rename from include/qapi/qmp/json-writer.h
rename to include/qobject/json-writer.h
diff --git a/include/qapi/qmp/qbool.h b/include/qobject/qbool.h
similarity index 100%
rename from include/qapi/qmp/qbool.h
rename to include/qobject/qbool.h
diff --git a/include/qapi/qmp/qdict.h b/include/qobject/qdict.h
similarity index 100%
rename from include/qapi/qmp/qdict.h
rename to include/qobject/qdict.h
diff --git a/include/qapi/qmp/qerror.h b/include/qobject/qerror.h
similarity index 100%
rename from include/qapi/qmp/qerror.h
rename to include/qobject/qerror.h
diff --git a/include/qapi/qmp/qjson.h b/include/qobject/qjson.h
similarity index 100%
rename from include/qapi/qmp/qjson.h
rename to include/qobject/qjson.h
diff --git a/include/qapi/qmp/qlist.h b/include/qobject/qlist.h
similarity index 100%
rename from include/qapi/qmp/qlist.h
rename to include/qobject/qlist.h
diff --git a/include/qapi/qmp/qlit.h b/include/qobject/qlit.h
similarity index 100%
rename from include/qapi/qmp/qlit.h
rename to include/qobject/qlit.h
diff --git a/include/qapi/qmp/qnull.h b/include/qobject/qnull.h
similarity index 100%
rename from include/qapi/qmp/qnull.h
rename to include/qobject/qnull.h
diff --git a/include/qapi/qmp/qnum.h b/include/qobject/qnum.h
similarity index 100%
rename from include/qapi/qmp/qnum.h
rename to include/qobject/qnum.h
diff --git a/include/qapi/qmp/qobject.h b/include/qobject/qobject.h
similarity index 100%
rename from include/qapi/qmp/qobject.h
rename to include/qobject/qobject.h
diff --git a/include/qapi/qmp/qstring.h b/include/qobject/qstring.h
similarity index 100%
rename from include/qapi/qmp/qstring.h
rename to include/qobject/qstring.h
diff --git a/qapi/qmp/dispatch.h b/qapi/qmp/dispatch.h
new file mode 120000
index 0000000000..ffedc3971d
--- /dev/null
+++ b/qapi/qmp/dispatch.h
@@ -0,0 +1 @@
+../../include/qapi/qmp-registry.h
\ No newline at end of file
diff --git a/qapi/qmp/json-parser.h b/qapi/qmp/json-parser.h
new file mode 120000
index 0000000000..059cb73fa8
--- /dev/null
+++ b/qapi/qmp/json-parser.h
@@ -0,0 +1 @@
+../../include/qobject/json-parser.h
\ No newline at end of file
diff --git a/qapi/qmp/json-writer.h b/qapi/qmp/json-writer.h
new file mode 120000
index 0000000000..3e952f4c97
--- /dev/null
+++ b/qapi/qmp/json-writer.h
@@ -0,0 +1 @@
+../../include/qobject/json-writer.h
\ No newline at end of file
diff --git a/qapi/qmp/qbool.h b/qapi/qmp/qbool.h
new file mode 120000
index 0000000000..443c881cf8
--- /dev/null
+++ b/qapi/qmp/qbool.h
@@ -0,0 +1 @@
+../../include/qobject/qbool.h
\ No newline at end of file
diff --git a/qapi/qmp/qdict.h b/qapi/qmp/qdict.h
new file mode 120000
index 0000000000..8183614eae
--- /dev/null
+++ b/qapi/qmp/qdict.h
@@ -0,0 +1 @@
+../../include/qobject/qdict.h
\ No newline at end of file
diff --git a/qapi/qmp/qerror.h b/qapi/qmp/qerror.h
new file mode 120000
index 0000000000..cf210737a3
--- /dev/null
+++ b/qapi/qmp/qerror.h
@@ -0,0 +1 @@
+../../include/qobject/qerror.h
\ No newline at end of file
diff --git a/qapi/qmp/qjson.h b/qapi/qmp/qjson.h
new file mode 120000
index 0000000000..85b48c5bfd
--- /dev/null
+++ b/qapi/qmp/qjson.h
@@ -0,0 +1 @@
+../../include/qobject/qjson.h
\ No newline at end of file
diff --git a/qapi/qmp/qlist.h b/qapi/qmp/qlist.h
new file mode 120000
index 0000000000..d40db0a12b
--- /dev/null
+++ b/qapi/qmp/qlist.h
@@ -0,0 +1 @@
+../../include/qobject/qlist.h
\ No newline at end of file
diff --git a/qapi/qmp/qlit.h b/qapi/qmp/qlit.h
new file mode 120000
index 0000000000..5dd5ac8ccb
--- /dev/null
+++ b/qapi/qmp/qlit.h
@@ -0,0 +1 @@
+../../include/qobject/qlit.h
\ No newline at end of file
diff --git a/qapi/qmp/qnull.h b/qapi/qmp/qnull.h
new file mode 120000
index 0000000000..944769d44b
--- /dev/null
+++ b/qapi/qmp/qnull.h
@@ -0,0 +1 @@
+../../include/qobject/qnull.h
\ No newline at end of file
diff --git a/qapi/qmp/qnum.h b/qapi/qmp/qnum.h
new file mode 120000
index 0000000000..8038e2f4d6
--- /dev/null
+++ b/qapi/qmp/qnum.h
@@ -0,0 +1 @@
+../../include/qobject/qnum.h
\ No newline at end of file
diff --git a/qapi/qmp/qobject.h b/qapi/qmp/qobject.h
new file mode 120000
index 0000000000..89d9118cfd
--- /dev/null
+++ b/qapi/qmp/qobject.h
@@ -0,0 +1 @@
+../../include/qobject/qobject.h
\ No newline at end of file
diff --git a/qapi/qmp/qstring.h b/qapi/qmp/qstring.h
new file mode 120000
index 0000000000..24f48de18a
--- /dev/null
+++ b/qapi/qmp/qstring.h
@@ -0,0 +1 @@
+../../include/qobject/qstring.h
\ No newline at end of file